#ifndef CORE_VIEW_H
#define CORE_VIEW_H

#include "core/Matrix.h"

typedef struct {
    Matrix view;
    Vector3 back;
    Vector3 down;
    Vector3 front;
    Vector3 left;
    Vector3 right;
    Vector3 up;
} View;

void initView(View* v);
void updateDirections(View* v, float lengthAngle, float widthAngle);
void updateDirectionsQ(View* v, const Quaternion* q);
Matrix* updateMatrix(View* v, const Vector3* pos);

#endif
